unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    L_NAME: TLabel;
    BT_USB_OPEN: TButton;
    BT_USB_CLOSE: TButton;
    L_SN: TLabel;
    BT_INFO: TButton;
    RX_USB_TIMER: TTimer;
    BT_SET_RTC: TButton;
    GroupBox2: TGroupBox;
    BT_CAN_INIT: TButton;
    BT_CAN_START: TButton;
    BT_CAN_STOP: TButton;
    BT_CAN_LISTEN: TButton;
    BT_CAN_SEND: TButton;
    Memo1: TMemo;
    BT_CAN_STATUS_ON: TButton;
    BT_CAN_STATUS_OFF: TButton;
    L_HV: TLabel;
    L_SV: TLabel;
    L_SN1: TLabel;
    BT_CAN_SEND_ECHO: TButton;
    GroupBox3: TGroupBox;
    L_STATUS_CNT: TLabel;
    L_CAN_OP: TLabel;
    L_ERR_RX: TLabel;
    L_ERR_TX: TLabel;
    L_CAN_BR: TLabel;
    L_CAN_LEC: TLabel;
    L_CAN_INFO: TLabel;
    L_CAN_BUSLOAD: TLabel;
    L_CAN_BUSLOAD_MAX: TLabel;
    procedure BT_USB_OPENClick(Sender: TObject);
    procedure BT_USB_CLOSEClick(Sender: TObject);
    procedure BT_INFOClick(Sender: TObject);
    procedure RX_USB_TIMERTimer(Sender: TObject);
    procedure BT_SET_RTCClick(Sender: TObject);
    procedure BT_CAN_INITClick(Sender: TObject);
    procedure BT_CAN_STARTClick(Sender: TObject);
    procedure BT_CAN_STOPClick(Sender: TObject);
    procedure BT_CAN_STATUS_ONClick(Sender: TObject);
    procedure BT_CAN_STATUS_OFFClick(Sender: TObject);
    procedure BT_CAN_LISTENClick(Sender: TObject);
    procedure BT_CAN_SENDClick(Sender: TObject);
    procedure BT_CAN_SEND_ECHOClick(Sender: TObject);
  private
    { Private declarations }
  public
  b_TIMER_OFF:boolean;
  i_ST_CNT:integer;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
CfgUnit,
D2XXUnit;

{$R *.dfm}


procedure CRUSB_Spartan_CAN_Staus(stat:byte);
begin
     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$02;  //
     FT_Out_Buffer[3] :=$01;   //
     FT_Out_Buffer[4] :=stat;   //
     FT_Out_Buffer[5] :=0;   //
     FT_Out_Buffer[6] :=0;   //
     FT_Out_Buffer[7] :=0;   //
     FT_Out_Buffer[8] :=0;   //
     FT_Out_Buffer[9] :=0;   //
     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;

procedure CRUSB_Spartan_CAN_Start;
begin
     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$01;  //
     FT_Out_Buffer[3] :=$01;   //
     FT_Out_Buffer[4] :=$01;   //   Normal
     FT_Out_Buffer[5] :=0;   //
     FT_Out_Buffer[6] :=0;   //
     FT_Out_Buffer[7] :=0;   //
     FT_Out_Buffer[8] :=0;   //
     FT_Out_Buffer[9] :=0;   //
     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;

procedure CRUSB_Spartan_CAN_Stop;
begin
     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$01;  //
     FT_Out_Buffer[3] :=0;   //   Channel
     FT_Out_Buffer[4] :=0;   //
     FT_Out_Buffer[5] :=0;   //
     FT_Out_Buffer[6] :=0;   //
     FT_Out_Buffer[7] :=0;   //
     FT_Out_Buffer[8] :=0;   //
     FT_Out_Buffer[9] :=0;   //
     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;

procedure CRUSB_Spartan_CAN_Silent;
begin
     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$01;  //
     FT_Out_Buffer[3] :=$01;   //
     FT_Out_Buffer[4] :=$03;   //   Silent
     FT_Out_Buffer[5] :=0;   //
     FT_Out_Buffer[6] :=0;   //
     FT_Out_Buffer[7] :=0;   //
     FT_Out_Buffer[8] :=0;   //
     FT_Out_Buffer[9] :=0;   //
     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;


procedure CRUSB_Spartan_Set_CAN_Boudrate(CAN_SPEED: word);
var
   pos:           integer;
   ui32_value:    dword;
   ui16_value:    word;
   ui8_value:     byte;
begin
      case CAN_SPEED of
           10:   begin ui16_value:=$DEE7;ui8_value:=12;end;
           20:   begin ui16_value:=$3331;ui8_value:=24;end;
           50:   begin ui16_value:=$1C1D;ui8_value:=24;end;
           100:  begin ui16_value:=$1C0E;ui8_value:=24;end;
           125:  begin ui16_value:=$1C0B;ui8_value:=24;ui32_value:=125000;end;
           250:  begin ui16_value:=$1C05;ui8_value:=24;end;
           500:  begin ui16_value:=$1C02;ui8_value:=24;end;
           800:  begin ui16_value:=$3301;ui8_value:=24;end;
           1000: begin ui16_value:=$3300;ui8_value:=24;end;
      end;

     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$03;  //
     FT_Out_Buffer[3] :=$01;   //
     FT_Out_Buffer[4] :=(ui16_value shr 8);   //
     FT_Out_Buffer[5] :=ui16_value;   //
     FT_Out_Buffer[6] :=ui8_value;   //
     FT_Out_Buffer[7] :=(ui32_value shr 24);   //
     FT_Out_Buffer[8] :=(ui32_value shr 16);   //
     FT_Out_Buffer[9] :=(ui32_value shr 8);  //
     FT_Out_Buffer[10]:=ui32_value;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;
     Write_USB_Device_Buffer(16);
end;

procedure CRUSB_Spartan_Set_RTC;
var
   DATE_TIME: TDateTime;
   w_Year, w_Month, w_Day:WORD;
   w_Hour, w_Min, w_Sec, w_MSec:WORD;
   ui8_VALUE:byte;

begin
     DATE_TIME:=now;
     DecodeDate(DATE_TIME, w_Year, w_Month, w_Day);
     DecodeTime(DATE_TIME, w_Hour, w_Min, w_Sec, w_MSec);

     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$10;  //
     FT_Out_Buffer[3] :=$01;   //

     ui8_VALUE:=w_Year-2000;
     FT_Out_Buffer[4]:=ui8_VALUE;   //

     ui8_VALUE:=w_Month;
     FT_Out_Buffer[5] :=ui8_VALUE;   //

     ui8_VALUE:=w_Day;
     FT_Out_Buffer[6] :=ui8_VALUE;   //

     ui8_VALUE:=w_Hour;
     FT_Out_Buffer[7] :=ui8_VALUE;   //

     ui8_VALUE:=w_Min;
     FT_Out_Buffer[8] :=ui8_VALUE;   //

     ui8_VALUE:=w_Sec;
     FT_Out_Buffer[9] :=ui8_VALUE;   //

     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;



procedure CRUSB_Spartan_Get_Info;
begin
     FT_Out_Buffer[0] :=$23;  // #
     FT_Out_Buffer[1] :=$FF;  //
     FT_Out_Buffer[2] :=$FF;  //
     FT_Out_Buffer[3] :=$01;   //
     FT_Out_Buffer[4] :=0;   //
     FT_Out_Buffer[5] :=0;   //
     FT_Out_Buffer[6] :=0;   //
     FT_Out_Buffer[7] :=0;   //
     FT_Out_Buffer[8] :=0;   //
     FT_Out_Buffer[9] :=0;   //
     FT_Out_Buffer[10]:=0;   //
     FT_Out_Buffer[11]:=0;   //
     FT_Out_Buffer[12]:=0;   //
     FT_Out_Buffer[13]:=0;   //
     FT_Out_Buffer[14]:=0;   //
     FT_Out_Buffer[15]:=$0D;   //
     Write_USB_Device_Buffer(16);
end;

procedure TForm1.BT_INFOClick(Sender: TObject);

begin
     CRUSB_Spartan_Get_Info;

      {

                    CRUSB_Spartan_Set_CAN_Boudrate(1);
                    if DLG_CAN_SPEED.CB_CAN_LISTEN_1.Checked=true then
                     CRUSB_Spartan_CAN_Silent(1)
                    else
                      CRUSB_Spartan_CAN_Start(1);

                    CRUSB_Spartan_Status_ON(1);
                    CRUSB_Spartan_Start_manage();

         }


end;

procedure TForm1.BT_USB_CLOSEClick(Sender: TObject);
begin
     Close_USB_Device;
     BT_USB_OPEN.Enabled:=true;
     BT_USB_CLOSE.Enabled:=false;
     BT_INFO.Enabled:=false;
     BT_SET_RTC.Enabled:=false;
      BT_CAN_INIT.Enabled:=false;
     L_NAME.Caption:='Name: ...';
     L_SN.Caption:='SN: ...';
     L_STATUS_CNT.Caption:='...';
     b_TIMER_OFF:=true;
end;

procedure TForm1.BT_USB_OPENClick(Sender: TObject);
var
    q,i_cnt:integer;
    B_DEV_CNT:byte;
begin
     GetFTDeviceCount;
     B_DEV_CNT:=FT_Device_Count;

     If B_DEV_CNT >0 then
     begin
          GetFTDeviceDescription(0);
          if FT_Device_String='CRUSB Spartan' then
          begin
               L_NAME.Caption:='Name: '+FT_Device_String;;
               GetFTDeviceSerialNo(0);
               L_SN.Caption:='SN: '+FT_Device_String;
               if Open_USB_Device_By_Serial_Number(FT_Device_String) = FT_OK  then
               begin
                    b_TIMER_OFF:=false;
                    RX_USB_TIMER.Enabled:=true;
                    BT_USB_OPEN.Enabled:=false;
                    BT_USB_CLOSE.Enabled:=TRUE;
                    BT_INFO.Enabled:=true;
                    BT_SET_RTC.Enabled:=true;
                    BT_CAN_INIT.Enabled:=true;
                    i_ST_CNT:=0;
               end;

          end;
     end;
end;


procedure TForm1.BT_CAN_INITClick(Sender: TObject);
begin
     CRUSB_Spartan_Set_CAN_Boudrate(125);
     BT_CAN_INIT.Enabled:=false;
     BT_CAN_START.Enabled:=true;
     BT_CAN_STOP.Enabled:=false;
     BT_CAN_LISTEN.Enabled:=true;
end;



procedure TForm1.BT_CAN_STARTClick(Sender: TObject);
begin
     CRUSB_Spartan_CAN_Start;
     BT_CAN_START.Enabled:=false;
     BT_CAN_LISTEN.Enabled:=false;

     BT_CAN_STOP.Enabled:=true;
     BT_CAN_SEND.Enabled:=true;
     BT_CAN_SEND_ECHO.Enabled:=true;
     BT_CAN_STATUS_ON.Enabled:=true;
     BT_CAN_STATUS_OFF.Enabled:=true;
end;

procedure TForm1.BT_CAN_STOPClick(Sender: TObject);
begin
     CRUSB_Spartan_CAN_Stop;

     BT_CAN_START.Enabled:=true;
     BT_CAN_LISTEN.Enabled:=true;
     BT_CAN_STOP.Enabled:=false;
     BT_CAN_SEND.Enabled:=false;
     BT_CAN_SEND_ECHO.Enabled:=false;
     BT_CAN_STATUS_ON.Enabled:=false;
     BT_CAN_STATUS_OFF.Enabled:=false;
end;

procedure TForm1.BT_CAN_LISTENClick(Sender: TObject);
begin
     CRUSB_Spartan_CAN_Silent;
end;

procedure TForm1.BT_CAN_SENDClick(Sender: TObject);
var
    ID:dword;
    EXT:byte;
    ECHO:byte;
    DLC:byte;
    TX:byte;
    RTR:byte;
    INFO:byte;
begin
     ID:=$181;
     EXT:=0;
     ECHO:=0;
     DLC:=8;
     RTR:=0;

     INFO:=0;
     if EXT=1  then  INFO:=INFO+$20;
     if RTR=1  then  INFO:=INFO+$40;
     if ECHO=1 then  INFO:=INFO+$80;

     INFO:=INFO+$10;    //Tx
     INFO:=INFO+DLC;

     FT_Out_Buffer[0]:= $23;
     FT_Out_Buffer[1]:= 1;
     FT_Out_Buffer[2]:= ID shr 24;
     FT_Out_Buffer[3]:= ID shr 16;
     FT_Out_Buffer[4]:= ID shr 8;
     FT_Out_Buffer[5]:= ID;

     FT_Out_Buffer[6]:= INFO;

     FT_Out_Buffer[7]:= 1;
     FT_Out_Buffer[8]:= 2;
     FT_Out_Buffer[9]:= 3;
     FT_Out_Buffer[10]:=4;
     FT_Out_Buffer[11]:=5;
     FT_Out_Buffer[12]:=6;
     FT_Out_Buffer[13]:=7;
     FT_Out_Buffer[14]:=8;

     FT_Out_Buffer[15]:=$0D;
     Write_USB_Device_Buffer(16);
end;

procedure TForm1.BT_CAN_STATUS_ONClick(Sender: TObject);
begin
     CRUSB_Spartan_CAN_Staus(1);
end;

procedure TForm1.BT_CAN_STATUS_OFFClick(Sender: TObject);
begin
     CRUSB_Spartan_CAN_Staus(0);
end;

procedure TForm1.BT_CAN_SEND_ECHOClick(Sender: TObject);
var
    ID:dword;
    EXT:byte;
    ECHO:byte;
    DLC:byte;
    TX:byte;
    RTR:byte;
    INFO:byte;
begin
     ID:=$181;
     EXT:=0;
     ECHO:=1;
     DLC:=8;
     RTR:=0;

     INFO:=0;
     if EXT=1  then  INFO:=INFO+$20;
     if RTR=1  then  INFO:=INFO+$40;
     if ECHO=1 then  INFO:=INFO+$80;

     INFO:=INFO+$10;    //Tx
     INFO:=INFO+DLC;

     FT_Out_Buffer[0]:= $23;
     FT_Out_Buffer[1]:= 1;
     FT_Out_Buffer[2]:= ID shr 24;
     FT_Out_Buffer[3]:= ID shr 16;
     FT_Out_Buffer[4]:= ID shr 8;
     FT_Out_Buffer[5]:= ID;

     FT_Out_Buffer[6]:= INFO;

     FT_Out_Buffer[7]:= 1;
     FT_Out_Buffer[8]:= 2;
     FT_Out_Buffer[9]:= 3;
     FT_Out_Buffer[10]:=4;
     FT_Out_Buffer[11]:=5;
     FT_Out_Buffer[12]:=6;
     FT_Out_Buffer[13]:=7;
     FT_Out_Buffer[14]:=8;

     FT_Out_Buffer[15]:=$0D;
     Write_USB_Device_Buffer(16);
end;

procedure TForm1.BT_SET_RTCClick(Sender: TObject);
begin
     CRUSB_Spartan_Set_RTC;
end;

procedure TForm1.RX_USB_TIMERTimer(Sender: TObject);

 var
   I:           integer;
   i16_value:   integer;
   q,v:         integer;


procedure CAN_DECODE;
var
    ui8_value:byte;
    ui16_value:word;
    ui32_value:dword;
    s_CAN_FRAME:string;
    i:integer;
begin

     if FT_In_Buffer[0]=$23 then
     begin

          if (FT_In_Buffer[1]=$01) then      //CAN
          begin
               ui32_value:=FT_In_Buffer[2];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[3];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[4];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[5];

               s_CAN_FRAME:='';

               if (FT_In_Buffer[6] and $10)=$10  then
                  s_CAN_FRAME:=s_CAN_FRAME+'Tx '
               else
                  s_CAN_FRAME:=s_CAN_FRAME+'Rx ';


               if (FT_In_Buffer[6] and $20)=$20  then
                  s_CAN_FRAME:=s_CAN_FRAME+'29bit '
               else
                  s_CAN_FRAME:=s_CAN_FRAME+'11bit ';




               s_CAN_FRAME:=s_CAN_FRAME+Format('%.8X', [ui32_value])+'   ';

               ui8_value:=FT_In_Buffer[6] and $0F;
               if ui8_value>8 then ui8_value:=8;

               s_CAN_FRAME:=s_CAN_FRAME+format('%.2X',[ui8_value])+'  ';

               if (FT_In_Buffer[6] and $40)=$40  then
               begin
                  s_CAN_FRAME:=s_CAN_FRAME+'RTR ';
               end
               else
               begin
                   for I := 0 to ui8_value-1 do
                   begin
                        s_CAN_FRAME:=s_CAN_FRAME+format('%.2X',[FT_In_Buffer[i+7]])+' ';
                   end;
               end;

               s_CAN_FRAME:=s_CAN_FRAME+'  DATE='+inttostr(2000+FT_In_Buffer[15])+'.';
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(FT_In_Buffer[16])+'.';
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(FT_In_Buffer[17])+'   ';
               s_CAN_FRAME:=s_CAN_FRAME+'TIME=';
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(FT_In_Buffer[18])+':';
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(FT_In_Buffer[19])+':';
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(FT_In_Buffer[20])+'.';

               ui16_value:=FT_In_Buffer[21];
               ui16_value:=ui16_value shl 8;
               ui16_value:=ui16_value+FT_In_Buffer[22];
               s_CAN_FRAME:=s_CAN_FRAME+inttostr(ui16_value);

               memo1.Lines.Add(s_CAN_FRAME);


          end;


          if (FT_In_Buffer[1]=$FF) and (FT_In_Buffer[2]=$FF) then
          begin
               L_HV.Caption:='Hardware: '+inttostr(FT_In_Buffer[4])+'.'+inttostr(FT_In_Buffer[5]);
               L_SV.Caption:='Software: '+inttostr(FT_In_Buffer[6])+'.'+inttostr(FT_In_Buffer[7]);

               ui32_value:=FT_In_Buffer[8];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[9];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[10];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[11];
               L_SN1.Caption:=inttostr(ui32_value);
          end;

          if (FT_In_Buffer[1]=$FF) and (FT_In_Buffer[2]=$02) then
          begin
               i_ST_CNT:=i_ST_CNT+1;
               L_STATUS_CNT.Caption:='CAN Status received: '+inttostr(i_ST_CNT);
               case FT_In_Buffer[4] of

                 0:L_CAN_OP.Caption:='CAN: STOP';
                 1:L_CAN_OP.Caption:='CAN: START';
                 2:L_CAN_OP.Caption:='CAN: LISTEN';

               end;


              L_CAN_INFO.Caption:='Info: '+inttostr(FT_In_Buffer[5]);

              ui16_value:=FT_In_Buffer[6];
              ui16_value:=ui16_value shl 8;
              ui16_value:=ui16_value+FT_In_Buffer[7];
              L_CAN_BUSLOAD.Caption:='CAN Busload: '+floattostr(ui16_value/10)+'%';;


              ui16_value:=FT_In_Buffer[12];
              ui16_value:=ui16_value shl 8;
              ui16_value:=ui16_value+FT_In_Buffer[13];
              L_CAN_BUSLOAD_MAX.Caption:='CAN Busload max: '+floattostr(ui16_value/10)+'%';

              ui16_value:=FT_In_Buffer[8];
              ui16_value:=ui16_value shl 8;
              ui16_value:=ui16_value+FT_In_Buffer[9];
              L_ERR_RX.Caption:='CAN Error Rx: '+inttostr(ui16_value);

              ui16_value:=FT_In_Buffer[10];
              ui16_value:=ui16_value shl 8;
              ui16_value:=ui16_value+FT_In_Buffer[11];
              L_ERR_TX.Caption:='CAN Error Tx: '+inttostr(ui16_value);

               ui32_value:=FT_In_Buffer[14];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[15];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[16];
               ui32_value:=ui32_value shl 8;
               ui32_value:=ui32_value+FT_In_Buffer[17];
               L_CAN_BR.Caption:='CAN Boudrate: '+inttostr(ui32_value);


              L_CAN_LEC.Caption:='CAN LEC: '+inttostr(FT_In_Buffer[18]);
          end;



     end;

end;

begin
     try
        I:=Get_USB_Device_QueueStatus;
        if FT_Q_Bytes>=24 then
        begin
             Read_USB_Device_Buffer(24);

             CAN_DECODE;
        end;

     except

     end;

      if b_TIMER_OFF=true then
      begin
           RX_USB_TIMER.Enabled:=false;
      end;
end;

end.
